#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define NMAX 1000000

void setRandomSeed( unsigned RandomSeed);
int SimulaProve(int n, float p);
void rbinom(int n, float p, int vs[], int N);

//--------------------------------------------------
int main(int argc, char *argv[]) {
  int N, n, i;
  int vs[NMAX] = {0};
  float p;
  float sx=0., sx2=0., m, var, sigma;
  FILE *fp;
  
  if (argc < 4) {
    puts("Devi dare N, n e p");
    return(0);
  }

  N = atoi(argv[1]);
  n = atoi(argv[2]);
  p = atof(argv[3]);

  if (n<1) {
    puts("n deve essere positivo");
    return(0);
  }
  if (p<0 || p>1) {
    puts("1 deve essere compreso fra 0 e 1");
    return(0);
  }
  if (N>NMAX) {
      printf("n non può essere maggiore di %d\n", NMAX);
    return(0);
  } 
  printf("N=%d, n=%d, p=%.3f\n", N, n, p);


  // setRandomSeed(0);       // inizializzazione durante il debug
  setRandomSeed(1234567);    // inizializzazione 'finale', con il proprio
                             // nr di matricola (qui inventato) per produrre
                             // il file da analizzare in R nell'ultimo punto
  rbinom(n, p, vs, N);

  fp = fopen("sequenza_successi.txt", "w");
  for(i=0; i<N; i++) {
    sx  += (float) vs[i];
    sx2 += (float) vs[i]*vs[i];
    fprintf(fp, "%d\n", vs[i]); 
  }
  fclose(fp);
  m   = sx / (float) N;
  var = sx2 / (float) N - m * m;
  sigma = sqrt(var);

  printf("media = %f,  media x^2 = %.4e,  sigma = %f\n", m, sx2/ (float) N, sigma );
  
  return(0);
}

//----------------------------------------
void rbinom(int n, float p, int vs[], int N){
  int i;

  for (i=0; i<N; i++) {
    vs[i] = SimulaProve(n, p);
    // printf("[rbinom] %d\n", vs[i]);
  }
  
}


//----------------------------------------
int SimulaProve(int n, float p) {
  int i, s=0;
  float runif;
  
  for(i=0; i<n; i++) {
     runif = (float) rand() / (float) RAND_MAX;
     if(runif <= p) s += 1;        
  }
  return(s);
}

//---------------------------------------------------
void setRandomSeed( unsigned RandomSeed) {
  
  // se RandomSeed==0  usa il tempo del computer
  // altrimenti usa il numero passato come argomento
  // Nota: RICHIEDE gli header stdlib.h e time.h
  
  time_t t;

  if (RandomSeed == 0 ) {     // se == 0 si usa il tempo
     RandomSeed = (unsigned) time(&t);
  }

  //  printf("seed %u\n", RandomSeed );
  srand( RandomSeed );
}
